# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::ImageSearch::V1_0
  module Models
    #
    # Defines the category of trending images.
    #
    class TrendingImagesCategory

      include MsRestAzure

      # @return [String] The name of the image category. For example, Popular
      # People Searches.
      attr_accessor :title

      # @return [Array<TrendingImagesTile>] A list of images that are trending
      # in the category. Each tile contains an image and a URL that returns
      # more images of the subject. For example, if the category is Popular
      # People Searches, the image is of a popular person and the URL would
      # return more images of that person.
      attr_accessor :tiles


      #
      # Mapper for TrendingImagesCategory class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'TrendingImages/Category',
          type: {
            name: 'Composite',
            class_name: 'TrendingImagesCategory',
            model_properties: {
              title: {
                client_side_validation: true,
                required: true,
                serialized_name: 'title',
                type: {
                  name: 'String'
                }
              },
              tiles: {
                client_side_validation: true,
                required: true,
                serialized_name: 'tiles',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'TrendingImagesTileElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'TrendingImagesTile'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
